
      SUBROUTINE  ASSIGN(matranks)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C     ASSIGN                                                           C
C                                                                      C
C     DESCRIPTION                                                      C
C         SUBROUTINE TO ASSIGN VALUES TO VARIABLES                     C
C                                                                      C
C     CALLED BY MAIN                                                   C
C                                                                      C
C     USES ANDRAN, CUM, FINVC                                          C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C   DICTIONARY                                                         C
C   ==========                                                         C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C     INPUT VARIABLES                                                  C
C     ===============                                                  C
C                                                                      C
C           NVARS  - NUMBER OF VARIABLES                               C
C           NRUNS  - NUMBER OF RUNS                                    C
C           NRUN   - RUN NUMBER (VARYING BETWEEN NSTART AND NRUNS)     C
C           NRAN   - RUNNING RANDOM INTEGER                            C
C           DITR   - TRUNCATIONN VALUE                                 C
C           ITYPE  - TYPE OF PROBABILITY DISTRIBUTION FUNCTION         C
C           NINT   - NUMBER OF INTERVALS                               C
C           RANGE  - DISTRIBUTION PARAMETERS                           C
C           WEIGHT - STATISTICAL WEIGHT OF INTERVAL                    C
C           XX     - INTERVAL SUBDIVISION MATRIX                       C
C           MATSAM - RANK MATRIX                                       C
C                                                                      C
C     OUTPUT VARIABLES                                                 C
C     ================                                                 C
C                                                                      C
C           XVAR(NVARS) - PARAMETERS VALUE VECTOR                      C
C                                                                      C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      INCLUDE 'par.h'
      INCLUDE 'cparam.h'
      INCLUDE 'cvaria.h'
c      INCLUDE 'ccorre.h'
      INCLUDE 'cchara.h'
c     INCLUDE 'csobol.h'
      INCLUDE 'cfast.h'
C
      DOUBLE PRECISION CUM,FINVC
      DOUBLE PRECISION CP
C
	dimension MATRANKS(MXNVAR,MXNRUN)
	
C

      DO  10  I = 1, NVARS
            CP=VTEMP(I,NRUN)          

c          ELSE
c            IF( JOPT.EQ.3 )  THEN
c              IF( IDASH.EQ.0 )  THEN
c                  CP = VTEMP(I,NRUN)
c              ELSE
c                  CP = VTEMP(I+NVARS,NRUN)
c              ENDIF
c              J = NRUNS/2
c            ELSE
              J = MATRANKS(I,NRUN)
C
C
C                   RANDOM NUMBER GENERATOR
C                   =======================
C
c              C A L L   A N D R A N  (NRAN,XRAN)
C
c              CP=CUM(I,XX(I,J))+XRAN/NRUNS
c            ENDIF
c          ENDIF
 
          IF(ITYPE(I).GT.3) THEN
                 CP=CP* (1.-DITR)+DITR/2.
          ENDIF
          IF(   ((1.-CP).LT.1.E-4.AND.CP.LT.1.)   .OR.
     &          (CP.GE.1                      )      )  THEN
                    XVAR(I)=XX(I,NRUNS+1)
          ELSE
              IF(ITYPE(I).GT.3)   then

                XVAR(I)=FINVC(I,CP,XX(I,J))
              end if

              IF(ITYPE(I).EQ.1.OR.ITYPE(I).EQ.2)    THEN
c                  IF(JOPT.EQ.3.OR.JOPT.EQ.4)  THEN
                      XVAR(I)=XX(I,1)+(XX(I,NRUNS+1)-XX(I,1))*CP
c                  ELSE
c                      XVAR(I)=XX(I,J)+(XX(I,J+1)-XX(I,J))*XRAN
c                  ENDIF
              ENDIF
              IF(ITYPE(I).EQ.3) XVAR(I)=SQRT(CP/WEIGHT(I,1))
          ENDIF
          IF(ITYPE(I).EQ.2.OR.ITYPE(I).GE.5) XVAR(I)=10.**(XVAR(I))
   10 CONTINUE	    

      RETURN
      END
