      DOUBLE PRECISION FUNCTION FINVC(I,C,ST)                                   
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC        
C                                                                      C        
C     FINVC                                                            C        
C                                                                      C        
C     DESCRIPTION                                                      C        
C         INVERSE FUNCTION OF CUM                                      C        
C                                                                      C        
C     DESCRIPTION OF ARGUMENTS                                         C        
C         INPUT                                                        C        
C           I      - VARIABLE NUMBER                                   C        
C           C      -                                                   C        
C           ST     -                                                   C        
C                                                                      C        
C         OUTPUT                                                       C        
C           FINVC                                                      C        
C                                                                      C        
C     CALLED BY ASSIGN, EQUDIV                                         C        
C                                                                      C        
C     USES CUM                                                         C        
C                                                                      C        
C                                                                      C        
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC        
C                                                                               
      INCLUDE  'par.h'                                                          
      INCLUDE  'cparam.h'                                                       
      INCLUDE  'cvaria.h'                                                       
C                                                                               
C                   LOCAL DIMENSION                                             
C                   ===============                                             
C                                                                               
      DOUBLE PRECISION CUM                                                      
      REAL*8     F1,C,CUM1,CUM2,F3                                              
C                                                                               
C                                                                               
C-CHECK                                                                         
C     WRITE(6,*) '** FINVC ** C,ST'                                             
C     WRITE(6,*) C,ST                                                           
C-CHECK                                                                         
      EPSI=ABS(RANGE(I,1)/NRUNS/10.)                                            
      ERR=1./NRUNS/10.                                                          
      IF(C.LE.1.D+00) THEN                                                      
          X=ST                                                                  
          KITER=0                                                               
 10       KITER=KITER+1                                                         
          IF(KITER.GT.100) THEN                                                 
              WRITE(6,9001)                                                     
              WRITE(6,9002) I,ITYPE(I),NINT(I),C,ST,X,KITER,CUM1,CUM2,          
     &           (WEIGHT(I,J),J=1,NINT(I)),(RANGE(I,J),J=1,NINT(I)+1)           
              FINVC=X                                                           
              RETURN                                                            
          ENDIF                                                                 
          CUM1=CUM(I,X     )                                                    
          CUM2=CUM(I,X+EPSI)                                                    
          F1=C-CUM1                                                             
          D=(CUM2-CUM1)/EPSI                                                    
          IF(CUM1.EQ.CUM2) THEN                                                 
               WRITE(6,9002) I,ITYPE(I),NINT(I),C,ST,X,KITER,CUM1,CUM2,         
     &         (WEIGHT(I,J),J=1,NINT(I)),(RANGE(I,J),J=1,NINT(I)+1)             
               FINVC=X                                                          
               RETURN                                                           
          ENDIF                                                                 
          X=X+F1/D                                                              
          IF(ITYPE(I).EQ.6.AND.X.LT.RANGE(I,2)) THEN                            
              X=RANGE(I,2)*(1.00000001)                                         
          ENDIF                                                                 
          F3=C-CUM(I,X)                                                         
C         WRITE(6,9003) ST,X,D,F3                                               
          IF(ABS(F3).GT.ERR) GO TO 10                                           
          FINVC=X                                                               
          RETURN                                                                
      ELSE                                                                      
          WRITE(6,9002) I,ITYPE(I),NINT(I),C,ST,X,KITER,CUM1,CUM2,              
     &    (WEIGHT(I,J),J=1,NINT(I)),(RANGE(I,J),J=1,NINT(I)+1)                  
          FINVC=X                                                               
          RETURN                                                                
      ENDIF                                                                     
C                                                                               
C                             FORMAT                                            
C                             ======                                            
C                                                                               
 9001 FORMAT(1H ,' ====== KITER > 100 ====== ')                                 
 9002 FORMAT(1H ,'  WARNING : FINVC FAILURE ',/,                                
     &' VARIABLE = ',I3,/,                                                      
     &'  TYPE    = ',I3,/,                                                      
     &' NUMB. OF INTERV. = ',I3,/,                                              
     &' INPUT CUM. VALUE = ',D16.5,/,                                           
     &' STARTING X VALUE = ',E16.5,/,                                           
     &'  ACTUAL  X VALUE = ',F16.5,/,                                           
     &' NUMB. OF ITER.   = ',I6,/,                                              
     &'        CUM1      = ',D16.5,/,                                           
     &'        CUM2      = ',D16.5,/,                                           
     &' WEIGHTS AND RANGES  = ',10(1PE16.5,/),/,                                
     &' FINVC SET EQUAL TO ACTUAL X VALUE',/)                                   
C9003 FORMAT(' START = ',E12.3,' NEWX = ',E12.3,' DERIV = ',E12.3,              
C    &       ' DELTACUM = ',E12.3)                                              
      END                                                                       
